﻿#include "MQBasePlugin.h"
#include "MQWidget.h"
#include "CMQObject.h"

#ifndef _UIWindowDefine
#define _UIWindowDefine

class VertexMarker;

class VertexMarkerWindow : public MQWindow
{
public:
	VertexMarkerWindow(VertexMarker *plugin, MQWindowBase& parent);
	~VertexMarkerWindow();

	VertexMarker *m_pPlugin;

	int mode;

private:
	MQCheckBox *checkView;
	MQCheckBox *checkNormal;
	MQCheckBox *checkOverwrite;
	MQCheckBox *checkAlways;
	MQDoubleSpinBox *spinNormalLength;

	std::vector<MQButton*> m_button_label;
	std::vector<MQButton*> m_button_set;
	std::vector<MQButton*> m_button_clear;

	void resetall();
	BOOL viewswitch(MQWidgetBase *sender, MQDocument doc, MQWidgetMouseParam &param);
	BOOL selectback(MQWidgetBase *sender, MQDocument doc, MQWidgetMouseParam &param);
	BOOL set(MQWidgetBase *sender, MQDocument doc, MQWidgetMouseParam& param);
	BOOL clear(MQWidgetBase *sender, MQDocument doc, MQWidgetMouseParam& param);
	BOOL setcolor(MQWidgetBase *sender, MQDocument doc, MQWidgetMouseParam &param);

	BOOL viewChanged(MQWidgetBase *parent, MQDocument doc);
	BOOL normalChanged(MQWidgetBase *parent, MQDocument doc);
	BOOL overwriteChanged(MQWidgetBase *parent, MQDocument doc);
	BOOL viewAlways(MQWidgetBase *parent, MQDocument doc);
	BOOL changeNormalLength(MQWidgetBase *parent, MQDocument doc);

	BOOL callColorPanelDialog(const POINT &pos, MQColor &col);

	BOOL OnHide(MQWidgetBase *sender, MQDocument doc);
	//BOOL keyevent(MQWidgetBase *sender, MQDocument doc, MQWidgetKeyParam& param);
	friend class VertexMarker;
};

class SetColorDialog : public MQDialog
{
public:
	SetColorDialog(MQWindowBase &parent, VertexMarker *plugin, int r, int g, int b);
	~SetColorDialog() {}

	VertexMarker *m_pPlugin;

private:
	MQColorPanel*m_color;

	BOOL ok(MQWidgetBase *sender, MQDocument doc);
	BOOL keyevent(MQWidgetBase *sender, MQDocument doc, MQWidgetKeyParam& param);

	friend class VertexMarkerWindow;
};

#endif
